
<html>
<TITLE> JFLAP Publications 
</TITLE>

<Body>


<hr>

<H1> JFLAP Publications 
</H1>
<br>
<h2>
- we list papers we have published and others
have published that refer to JFLAP
</h2>
<hr>

<h2> Books </h2>
<br>

Susan Rodger and Thomas Finley, JFLAP - An Interactive Formal Languages and
Automata Package, ISBN 0763738344, Jones and Bartlett, 2006.
<a href="http://www.cs.duke.edu/csed/jflap/jflapbook/"> info </a>
<br>

<h2> Papers we have published </h2>


<p> Susan H. Rodger, Jinghui Lim, and Stephen Reading,
Increasing Interaction and Support in the Formal Languages and
Automata Theory Course, 
The 12th Annual Conference on Innovation and Technology in
Computer Science Education (ITiCSE 2007)
2007 (to appear)<a
href="http://www.cs.duke.edu/csed/rodger/papers/iticse07.pdf"> pdf </a>
<br>
<br> 

<p> Susan H. Rodger, Bart Bressler, Thomas Finley, and Stephen Reading,
Turning Automata Theory into a Hands-on Course, 
Thirty-seventh SIGCSE Technical Symposium on
Computer Science Education,  2006 (p. 379-383)<a href="http://www.cs.duke.edu/csed/rodger/papers/cse06.pdf"> pdf </a>

<br><br>

Ryan Cavalcante, Thomas Finley and Susan H. Rodger, A Visual and
Interactive
Automata Theory Course with JFLAP 4.0, 
Thirty-fifth SIGCSE Technical Symposium on
Computer Science Education,  2004 (p.140-144).
<a href="http://www.cs.duke.edu/csed/rodger/papers/cse04.pdf"> pdf </a>
<br><br>

S. H. Rodger, Using Hands-on Visualizations to Teach Computer Science
from Beginning Courses to Advanced Courses, Second Program Visualization 
Workshop, Hornstrup Centert, Denmark, p. 103-112, June 2002. 
<a href="http://www.cs.duke.edu/csed/rodger/papers/pviswk02.pdf"> pdf
(first draft) </a>
<br><br>

T. Hung and S. H. Rodger,
Increasing Visualization and Interaction in the Automata Theory Course,
Thirty-first SIGCSE Technical Symposium on
Computer Science Education, p. 6-10, 2000.
<A href="http://www.cs.duke.edu/~rodger/papers/cse00/cse00fin.html"> html</a>
and <a href="http://www.cs.duke.edu/csed/rodger/papers/cse00.ps.gz"> ps </a>
<br><br>

E. Gramond and S. H. Rodger,
Using JFLAP to Interact with Theorems in Automata Theory,
Thirtieth SIGCSE Technical Symposium on
Computer Science Education, p. 336-340, 1999.
<A href="http://www.cs.duke.edu/csed/rodger/papers/cse99.pdf"> pdf</a>
<br><br>

E. Gramond and S. H. Rodger, JFLAP:
An Aid to Studying Theorems in Automata Theory,
Integrating Technology into Computer Science Education,
Dublin, Ireland, p. 302, 1998. 

<br><br>

A. O. Bilska, K. H. Leider, M.
Procopiuc, O. Procopiuc, S. H. Rodger, 
J. R. Salemme and E. Tsang,
A Collection of Tools for Making Automata Theory and Formal Languages Come
Alive,
Twenty-eighth SIGCSE Technical Symposium on
Computer Science Education, p. 15-19, 1997.
<A href="http://www.cs.duke.edu/csed/rodger/papers/cse97flap.pdf"> pdf
</a>
<br><br>

M. Procopiuc, O. Procopiuc, and S. Rodger,
Visualization and Interaction in the Computer Science
Formal Languages Course with JFLAP,
1996 Frontiers in Education Conference,
Salt Lake City, Utah, p. 121-125, 1996.
<A href="http://www.cs.duke.edu/csed/rodger/papers/fie96.pdf">pdf
</a>
<br><br>

S. H. Rodger, Integrating Hands-On Work into the Formal Languages Course
via Tools and Programming,  Workshop on Implementing Automata,
Lecture Notes In Computer Science 1260, 
Springer-Verlag, p. 132-148, 
1996. (this version is an early draft)
<A href="http://www.cs.duke.edu/csed/rodger/papers/wia96.pdf"> pdf
</a>

<br><br>

D. Caugherty, and S. H. Rodger, NPDA: A Tool for Visualizing and
Simulating Nondeterministic Pushdown Automata, in Computational
Support for Discrete Mathematics, DIMACS Series in Discrete
Mathematics and Theoretical Computer Science, Vol. 15, N. Dean and G.
E. Shannon (ed.), American Mathematical Society, 1994, 365-377.
<A href="http://www.ams.org/bookstore"> (book)
</A>

<br><br>


S. Blythe, M. James, and S. H. Rodger,
LLparse and LRparse: Visual and Interactive Tools for
Parsing,
Proceedings of the Twenty-fifth SIGCSE Technical Symposium on
Computer Science Education,
1994, 208-212.<A href="http://www.cs.duke.edu/csed/rodger/papers/cse94.pdf">(pdf) </A>
<br><br>

E. Luce and S. H. Rodger,
A Visual Programming Environment for Turing Machines,
Proceedings of the IEEE Symposium on Visual Languages,
1993, 231-236.
<br><br>

M. LoSacco and S. H. Rodger,
FLAP: A Tool for Drawing and Simulating Automata,
ED-MEDIA 93, World Conference on Educational Multimedia and 
Hypermedia,
1993, 310-317.
<br><br>





<h2> Papers others have published using JFLAP </h2>

<ul>
<li> J. Jarvis and J. M. Lucas, Incorporating Transformations 
into JFLAP for Enhanced Understanding of Automata. 
ACM SIGSCE Bulletin, Volume 40, Issue 1, p. 14-18, March 2008.
<br><br>
Jarvis (AMD) and Lucas (SUNY, College at Brockport) modified JFLAP using a 
plug-in system that allows transformation to and from any automata. 
The goal was to assist in instructing students about topics such as 
the Church-Turing thesis and the theory of undecidability. The modified 
version of JFLAP was implemented in coursework at SUNY Brockport College.
<br><br>

<li> A. Merceron and  K. Yacef, Web-Based Learning Tools: 
Storing Usage Data Makes a Difference. Proceeding of 
the Sixth IASTED International Conference Web-Based 
Education - Volume 2, p. 104-109. Chamonix, France 2007.
<br><br>
Merceron and Yacef conducted analysis on the usage of JFLAP and Logic-ITA 
(A web-based tutoring system for logical formal proofs) and student feedback. 
JFLAP's usage as an extra resource in coursework at the University of 
Applied Science in Berlin was investigated using student surveys. The study 
verified JFLAP's benefits for students and found that the students who 
tried the tool praised its utility.
<br><br>

<li> C. I. Chesnevar, M. L. Cobo, and W. Yurcik, Using 
Theoretical Computer Simulators for Formal Languages and 
Automata Theory. ACM SIGCSE Bulletin, Volume 35, Issue 2, 
p. 33-37. New York, NY 2003.
<br><br>
Chesnevar, Cobo, and Yurcik's paper describes testing of several 
software tools used for teaching formal languages and automata theory 
at the Universidad Nacional del Sur, Argentina. The useful capability 
of JFLAP for students to integrate automata theory with the associated 
grammars was noted. The paper illustrated the efficacy of using multiple 
simulators on the same topics to enhance student understanding.
<br><br>

<li> A. R. M. Verma, A Visual and Interactive Automata 
Theory Course Emphasizing Breadth of Automata. Annual Joint 
Conference Integrating Technology into Computer Science Education, 
Proceedings of the 10th annual SIGCSE conference on Innovation and 
technology in computer science education, p. 325-329. Caparica, Portugal 2005.
<br><br>
Verma describes a revision in a Theory of Computing course 
program at the University of Houston that uses a modified version 
of JFLAP as a basis for more visualized teaching of automata theory. 
Student evaluations for the course responded positvely to the changes 
and some students were inspired by the changes to pursue further work 
on the course and materials.
<br><br>

<li> A. J. Rocker, C. M. Yauch, S. Yenduri, L.A. Perkins, and F. Zand, 
Paper-Based Dichotomous Key to Computer Based Application For Biological 
Identification. Journal of Computing Sciences in Colleges, Volume 22, 
Issue 5, p. 30-38, May 2007.
<br><br>
Researchers at the University of Southern Mississippi used JFLAP to design 
deterministic finite automata as alternatives to traditonally used, 
paper-based dichotomous keys for biological identification in taxonomy.
<br><br>

<li> A. L. Salmela and J. Tarhio. ACE: Automated Compiler Exercises. 
Kolin Kolistelut - Koli Calling 2004, Proceedings of the Fourth Finnish/Baltic 
Sea Conference on Computer Science Education. Koli, Finland 2004.
<br><br>
Salmela and Tarhio at the Helsinki University of Techonology have used 
JFLAP as a foundation for their Automated Compiler Exercises to be used 
in coursework. Their automation of assignments using JFLAP code is designed 
to increase interactivity by making constructive feedback immediate and 
implementing visualizations.
<br><br>

<li> Y. K. Tsay, Y. F. Chen, and K. N. Wu. Tool Support for 
Learning Buchi Automata and Linear Temporal Logic. Formal Methods 
in the Teaching Lab, Examples, Cases, Assignments, and Projects 
Enhancing Formal Methods Education. A Workshop at the Formal 
Methods 2006 Symposium, August 2006.
<br><br>
Tsay, Chen, and Wu created GOAL (Graphical interactive tool for 
Omega-Automata and temporal Logic) to help instruct students on 
Buchi automata and linear temporal logic with the usage and help of JFLAP code.
<br><br>


<li> Y. K. Tsay,  T. F. Chen, M. H. Tsai, W. C. Chan, C. J. Luo.
Goal Extended: Towards a Research Tool for Omega Automata and Temporal Logic.
In Proceedings of the 14th International Conference on Tools and Algorithms 
for the Construction and Analysis of Systems (TACAS 2008), LNCS 4963, 
346--350, March/April, 2008.
<br><br>
GOAL uses and modifies JFLAP source code as software for researching Omega automata and
temporal logic.
<br><br>


<li> Y. K. Tsay, Y. F. Chen, M. H. Tsai, K. N. Wu, W. C. Chan. GOAL: 
A Graphical Tool for Manipulating Buchi Automata and Temporal Formulae. 
In Proceedings of the 13th International Conference on Tools and Algorithms 
for the Construction and Analysis of Systems (TACAS 2007), LNCS 4424, 
466--471, March/April, 2007. 
<br><br>


<li> L. A. Sanchis, Computer Laboratories For The Theory of 
Computing Course. Journal of Computing Sciences In Colleges, 
Volume 16, Issue 4, p. 262-269, 2001.
<br><br>
Sanchis uses JfLAP for a variety of laboratory activities, which 
are described in the article. Many of JFLAP's  featured automata 
are utilized interactively in the labs. JFLAP is a popularly chosen 
option among students for constructing finite automata that recognizes tokens appearing in C++.
<br><br>


</ul>



<p> If you know of other papers that mention JFLAP, please send us the link
at jflap "at" cs.duke.edu. A short description of how the paper uses JFLAP
would also be appreciated. 
</p>
<br>
</Body>
</html>
